u = rand(1e2);

f = @() sum(log(u));
normal_time = timeit(f)

f = @() sumlog(u);
sumlog_time = timeit(f)

speedup = (normal_time / sumlog_time)

fprintf('\nSome of the sumlog time was overhead to make the function general,\n');
fprintf('so you can specify summing dimension and use nd-arrays. If you\n');
fprintf('always use matrices and sum over the first dimension, you can\n');
fprintf('call the base mex file directly for a bit more speed:\n\n');

f = @() sumlog_base(u);
sumlog_base_time = timeit(f)

speedup = (normal_time / sumlog_base_time)


%%% 

fprintf('\nNow we will compare performance on single precision numbers.\n');

u = single(rand(1e2));

f = @() sum(log(u));
normal_time = timeit(f)

f = @() sumlog(u);
sumlog_time = timeit(f)

speedup = (normal_time / sumlog_time)

fprintf('\nSome of the sumlog time was overhead to make the function general,\n');
fprintf('so you can specify summing dimension and use nd-arrays. If you\n');
fprintf('always use matrices and sum over the first dimension, you can\n');
fprintf('call the base mex file directly for a bit more speed:\n\n');

f = @() sumlog_base(u);
sumlog_base_time = timeit(f)

speedup = (normal_time / sumlog_base_time)

