function success = testequal(varargin)
%TESTEQUAL verbose version of ISEQUAL for use in test cases.
%
% success = testequal(x, y[, ...])
%
% Warns about NaNs, but treats them as equal.

% Iain Murray, November 2007, July 2008

success = isequalwithequalnans(varargin{:});

if success
    fprintf('OK         (tested inputs equal)\n');
    if any(isnan(varargin{1}(:)))
        fprintf('WARNING: some of the values tested were NaNs\n');
    end
else
    fprintf('FAILURE: inputs not equal\n');
end
